class AusgabenController < ApplicationController
  def start
      ryears=Transaction.find_by_sql("select distinct date_part('year', (timezone('UTC', post_date))) as postyear from transactions")
      run_years = []
      ryears.each {|ry| run_years << ry.postyear.to_int}
      $my_years = run_years.sort
      $no_years = run_years.length
     
      acc_types= Account.find_by_sql("select distinct account_type from accounts where account_type <> 'ROOT'")
      types = []
      acc_types.each {|type| types << type.account_type}
      $my_types = types
      $no_types = types.length
      @bank = Array.new($no_years + 2, 0)
      @bank[0] = "BANK"
      @cash = Array.new($no_years + 2, 0)
      @cash[0] = "CASH"
      @credit = Array.new($no_years + 2, 0)
      @credit[0] = "CREDIT"
      @liability= Array.new($no_years + 2, 0)
      @liability[0] = "LIABILITY"
      @asset = Array.new($no_years + 2, 0)
      @asset[0] = "ASSET"
      @stock = Array.new($no_years + 2, 0)
      @stock[0] = "STOCK"
      @mutual = Array.new($no_years + 2, 0)
      @mutual[0] = "MUTUAL"
      @equity = Array.new($no_years + 2, 0)
      @equity[0] = "EQUITY"
      @income = Array.new($no_years + 2, 0)
      @income[0] = "INCOME"
      @expense = Array.new($no_years + 2, 0)
      @expense[0] = "EXPENSE"
      @balance = Array.new($no_years + 2, 0)
      @balance[0] = "BALANCE"
      @pandl = Array.new($no_years + 2, 0)
      @pandl[0] = "P & L"
      @freecash = Array.new($no_years + 2, 0)
      @freecash[0] = "free salary"
      @salary = Array.new($no_years + 2, 0)
      @salary[0] = "Salary"
      # @savingplan = Array.new($no_years + 2, 0)
      # @savingplan[0] = "Saving Plans"
      
      year_min = $my_years[0]
      my_split = Split.yearly_per_type("BANK")
      run_years.each {|ry| 
          if my_split.has_key?(ry.to_s) then
             @bank[ry - year_min + 1] = my_split[ry.to_s]*0.01
             @bank[$no_years + 1] = @bank[$no_years + 1] + my_split[ry.to_s]*0.01
             @balance[ry - year_min + 1] = @balance[ry - year_min + 1] + @bank[ry - year_min + 1]
             @balance[$no_years + 1] = @balance[$no_years + 1] + @bank[ry - year_min + 1]
         end
         }
      my_split = Split.yearly_per_type("CASH")
      run_years.each {|ry|
          if my_split.has_key?(ry.to_s) then
             @cash[ry - year_min + 1] = my_split[ry.to_s]*0.01
             @cash[$no_years + 1] = @cash[$no_years + 1] + my_split[ry.to_s]*0.01
             @balance[ry - year_min + 1] = @balance[ry - year_min + 1] + @cash[ry - year_min + 1]
             @balance[$no_years + 1] = @balance[$no_years + 1] + @cash[ry - year_min + 1]
         end
         }

      my_split = Split.yearly_per_type("CREDIT")
      run_years.each {|ry| 
          if my_split.has_key?(ry.to_s) then                  
             @credit[ry - year_min + 1] = my_split[ry.to_s]*0.01
             @credit[$no_years + 1] = @credit[$no_years + 1] + my_split[ry.to_s]*0.01
             @balance[ry - year_min + 1] = @balance[ry - year_min + 1] + @credit[ry - year_min + 1]
             @balance[$no_years + 1] = @balance[$no_years + 1] + @credit[ry - year_min + 1]
         end
         }   
         
      my_split = Split.yearly_per_type("LIABILITY")
      run_years.each {|ry|
          if my_split.has_key?(ry.to_s) then
             @liability[ry - year_min + 1] = my_split[ry.to_s]*0.01
             @liability[$no_years + 1] = @liability[$no_years + 1] + my_split[ry.to_s]*0.01
             @balance[ry - year_min + 1] = @balance[ry - year_min + 1] + @liability[ry - year_min + 1]
             @balance[$no_years + 1] = @balance[$no_years + 1] + @liability[ry - year_min + 1]
         end
         }

      my_split = Split.yearly_per_type("ASSET")
      run_years.each {|ry| 
          if my_split.has_key?(ry.to_s) then                  
             @asset[ry - year_min + 1] = my_split[ry.to_s]*0.01
             @asset[$no_years + 1] = @asset[$no_years + 1] + my_split[ry.to_s]*0.01
             @balance[ry - year_min + 1] = @balance[ry - year_min + 1] + @asset[ry - year_min + 1]
             @balance[$no_years + 1] = @balance[$no_years + 1] + @asset[ry - year_min + 1]
         end
         }        
         
      my_split = Split.yearly_per_type("STOCK")
      run_years.each {|ry| 
          if my_split.has_key?(ry.to_s) then                  
             @stock[ry - year_min + 1] = my_split[ry.to_s]*0.01
             @stock[$no_years + 1] = @stock[$no_years + 1] + my_split[ry.to_s]*0.01
             @balance[ry - year_min + 1] = @balance[ry - year_min + 1] + @stock[ry - year_min + 1]
             @balance[$no_years + 1] = @balance[$no_years + 1] + @stock[ry - year_min + 1]
         end
         }
      my_split = Split.yearly_per_type("MUTUAL")
      run_years.each {|ry| 
          if my_split.has_key?(ry.to_s) then                  
             @mutual[ry - year_min + 1] = my_split[ry.to_s]*0.01
             @mutual[$no_years + 1] = @mutual[$no_years + 1] + my_split[ry.to_s]*0.01
             @balance[ry - year_min + 1] = @balance[ry - year_min + 1] + @mutual[ry - year_min + 1]
             @balance[$no_years + 1] = @balance[$no_years + 1] + @mutual[ry - year_min + 1]
         end
         }   
         
      my_split = Split.yearly_per_type("EQUITY")
      run_years.each {|ry| 
          if my_split.has_key?(ry.to_s) then                  
             @equity[ry - year_min + 1] = my_split[ry.to_s]*0.01
             @equity[$no_years + 1] = @equity[$no_years + 1] + my_split[ry.to_s]*0.01
             @balance[ry - year_min + 1] = @balance[ry - year_min + 1] + @equity[ry - year_min + 1]
             @balance[$no_years + 1] = @balance[$no_years + 1] + @equity[ry - year_min + 1]
         end
         }  
         
      my_split = Split.yearly_per_type("INCOME")
      run_years.each {|ry| 
          if my_split.has_key?(ry.to_s) then                  
             @income[ry - year_min + 1] = my_split[ry.to_s]*0.01
             @income[$no_years + 1] = @income[$no_years + 1] + my_split[ry.to_s]*0.01
             @pandl[ry - year_min + 1] = @pandl[ry - year_min + 1] + @income[ry - year_min + 1]
             @pandl[$no_years + 1] = @pandl[$no_years + 1] + @income[ry - year_min + 1]
         end
         }   
         
      my_split = Split.yearly_per_type("EXPENSE")
      run_years.each {|ry| 
          if my_split.has_key?(ry.to_s) then                  
             @expense[ry - year_min + 1] = my_split[ry.to_s]*0.01
             @expense[$no_years + 1] = @expense[$no_years + 1] + my_split[ry.to_s]*0.01
             @pandl[ry - year_min + 1] = @pandl[ry - year_min + 1] + @expense[ry - year_min + 1]
             @pandl[$no_years + 1] = @pandl[$no_years + 1] + @expense[ry - year_min + 1]
         end
         }

        my_split = Split.yearly_per_name("Gehalt")
        run_years.each {|ry|
           i = ry - year_min + 1
           if my_split.has_key?(ry.to_s) then    
              @salary[i] = @salary[i] +  my_split[ry.to_s]*0.01
              @salary[$no_years + 1] = @salary[$no_years + 1] + my_split[ry.to_s]*0.01
           end   
        }
        # my_savingplan = Savingplan.find(:all)
        # my_savingplan.each {|sp|
           # saving = Split.savingplan_yearly(sp.from_account, sp.to_account, sp.value_num)
           # run_years.each {|ry| 
             # if saving.has_key?(ry.to_s) then
                # i = ry - year_min + 1
                # @savingplan[i] = @savingplan[i] - saving[ry.to_s]*0.01
                # @savingplan[$no_years + 1] = @savingplan[$no_years + 1] - saving[ry.to_s]*0.01
             # end  
           # }
        # }
         run_years.each {|ry| 
            i = ry - year_min + 1
            @freecash[i] = @salary[i] + @expense[i]
            @freecash[$no_years + 1] = @freecash[$no_years + 1] + @freecash[i]
         }   
  end
  def type_details
     $my_type = params[:id]
  #   my_accounts=Account.find(:all, :conditions => ["account_type = ?", $my_type], :order => "parent_guid")
     my_accounts=Account.find(:all, :conditions => ["account_type = ? and commodity_guid <> '8300d82a40ba65fd1fd8f22e864efb50'", $my_type])
     $account_guids = []
     $no_accounts = my_accounts.length
     $sum = Array.new($no_accounts,0)
     details = Array.new(($no_years + 2) * $no_accounts, 0)
     0.upto(my_accounts.length - 1) {|y| details[y * ($no_years + 2)] = my_accounts[y].name}
     0.upto($no_years-1)  {|y|
       my_s = Split.account_yearly_by_type_and_year(params[:id], $my_years[y])
       my_s.each {|k, v| details[details.index(k) + y + 1] = v * 0.01
  #           # my_s.each {|k, v| details[k.to_i - year_min + y + 1] = v * 0.01}
            
        }  
       }
      0.upto(my_accounts.length - 1) {|y|
         $account_guids[y] = my_accounts[y].guid
         0.upto($no_years-1) {|v|
            $sum[y] =  $sum[y] + details[y * ($no_years + 2) + v +1]
           }
      }   
      
      @my_details = details
     render :template => 'details/by_accounttype'
 end
 def annual_details
    $my_year = params[:id]
    pandl = Array.new(14*3, 0)
    pandl[28] = 'Result'
    my_type='EXPENSE'
    expense_per_month = Split.monthly_by_type_and_year(my_type,$my_year)
    pandl[14] = my_type
    expense_per_month.each {|k,v| pandl[k.to_i+14] = v*0.01
        pandl[27] = pandl[27] + v*0.01
        pandl[k.to_i+28] = pandl[k.to_i+28] + v*0.01
        }
    
    my_accounts=Account.find(:all, :conditions => ["account_type = ?", my_type])
    $no_accounts_expense = my_accounts.length
    $expense_guids = []
    monthly = Array.new((14) * $no_accounts_expense, 0)
    0.upto(my_accounts.length - 1) {|y|
          $expense_guids[y] = my_accounts[y].guid
          monthly[y * (14)] = my_accounts[y].name
          my_s = Split.account_monthly_by_year(my_accounts[y].guid, $my_year)
          my_s.each {|k, v| monthly[k.to_i + y*14] = v * 0.01
          monthly[13 + y*14] = monthly[13 + y*14] + v * 0.01
          }
    }
    @my_monthly_expense = monthly
         
    my_type='INCOME'
    income_per_month = Split.monthly_by_type_and_year(my_type,$my_year)
    pandl[0] = my_type
    income_per_month.each {|k,v| pandl[k.to_i] = v*0.01
        pandl[13] = pandl[13] + v*0.01
        pandl[k.to_i+28] = pandl[k.to_i+28] + v*0.01}
        
    pandl[41]=pandl[13]+pandl[27]    
    @thepandl = pandl
    $income_guids = []
    my_accounts=Account.find(:all, :conditions => ["account_type = ?", my_type])
    $no_accounts_income = my_accounts.length
    monthly = Array.new((14) * $no_accounts_income, 0)
    0.upto(my_accounts.length - 1) {|y|
          $income_guids[y] = my_accounts[y].guid
          monthly[y * (14)] = my_accounts[y].name
          my_s = Split.account_monthly_by_year(my_accounts[y].guid, $my_year)
          my_s.each {|k, v| monthly[k.to_i + y*14] = v * 0.01
             monthly[13 + y*14] = monthly[13 + y*14] + v * 0.01
             }
    }
    @my_monthly_income = monthly
    
    monthly = Array.new((14) * 4, 0)
    salary = Account.find(:first, :conditions => ["name = ?", "Gehalt"])
    my_split = Split.account_monthly_by_year(salary, $my_year)    
    monthly[0] = 'Gehalt'
    my_split.each {|k, v| monthly[k.to_i] = v * 0.01
             monthly[13] = monthly[13] + v * 0.01
             }
    
    14.upto(27) {|i| monthly[i] = @thepandl[i]}
    
    # monthly[28] = 'Sparpläne'
    # my_savingplan = Savingplan.find(:all)
    # my_savingplan.each {|sp|
        # saving = Split.savingsplan_monthly(sp.from_account, sp.to_account, $my_year, sp.value_num)
        # 1.upto(12) {|month| 
             # if saving.has_key?(month.to_s) then
                # i = month + 28
                # monthly[i] = monthly[i] - saving[month.to_s]*0.01 
                # monthly[41] = monthly[41] -  saving[month.to_s]*0.01
             # end  
           # }
        # }
        monthly[42] = 'freies Gehalt' 
         1.upto(13) {|month| 
            i = month + 42
            monthly[i] = monthly[i-42] + monthly[i-28] + monthly[i-14]
         }   
         @freecash = monthly
    
    render :template => 'details/monthly'
    
 end
 def tx_yearly
   ac_guid = params[:id]
   $my_year = params[:year]
   tx = []
   i=0
   my_splits = Split.tx_list(ac_guid, $my_year)
   my_splits.each {|my_s|
      utc_time = my_s.transaction.post_date 
      tx[i] = $tz.utc_to_local(utc_time).strftime("%Y-%m-%d")
      tx[i+1] = my_s.value_num*0.01
      tx[i+2] = my_s.transaction.description
      i= i + 3
   }
   tx[i] = my_splits[0].account.account_type
   @tx_list = tx
   render :template => 'details/tx_list'
 end
 def tx_monthly
   $ac_guid = params[:id]
   $my_year = params[:year]
   my_month = params[:month]
   
   tx = []
   i=0
   my_splits = Split.tx_list_monthly($ac_guid, $my_year, my_month)
   my_splits.each {|my_s| 
      utc_time = my_s.transaction.post_date 
      tx[i] = $tz.utc_to_local(utc_time).strftime("%Y-%m-%d")
      # tx[i] = my_s.transaction.postdate.strftime("%Y-%m-%d")
      tx[i+1] = my_s.value_num*0.01
      tx[i+2] = my_s.transaction.description
      i= i + 3
   }
   tx[i] = my_splits[0].account.account_type
   @tx_list = tx
   render :template => 'details/tx_list'
 end
 def splitreport
   if params[:split][:desc2].blank? then
     myresult = Split.yearly_per_name_and_desc(params[:konto], params[:split][:desc1])
   else
     myresult = Split.yearly_per_name_and_2desc(params[:konto], params[:split][:desc1], params[:split][:desc2])
   end
   $sum = 0.0
   @result=myresult.sort
   @result.each {|res| res[1] = res[1] / 100.0}
   @result.each {|res| $sum = $sum + res[1] }
   render :template => 'ausgaben/splitsearch'
 end
end
 
