class Account < ActiveRecord::Base
 has_many :split, :foreign_key => "account_guid"
 has_many :transaction, :through => :split
 set_table_name "accounts"
 self.primary_key = "guid"
 # self.inheritance_column = "type_cti"
 def kontostand
   split.sum(:amount)
 end
 def yearly
   # split.sum(:amount, :joins => :transaction, :group => "postyear", :order => "postyear")
   split.sum(:amount, :joins => :transaction, :group => "date_part('year', (timezone('UTC', post_date)))", :order => "date_part('year', (timezone('UTC', post_date)))")
 end
 def monthly(my_year)
   split.sum(:amount, :joins => :transaction, :conditions => ["date_part('year', (timezone('UTC', post_date)))= ?", my_year], :group => "date_part('year', (timezone('UTC', post_date)))", :order => "date_part('month', (timezone('UTC', post_date)))")
   # split.sum(:amount, :joins => :transaction, :conditions => ["postyear= ?", my_year], :group => "postyear", :order => "postmonth")
 end
end
